//
//  TWService1FirstViewController.m
//  Trailwalker 1
//
//  Created by Jordi Saboya on 4/29/13.
//  Copyright (c) 2013 Jordi Saboya. All rights reserved.
//

#import "TWService1FirstViewController.h"
#import "TWGlobalData.h"
#import "TWDataSend.h"



@interface TWService1FirstViewController ()


@end

@implementation TWService1FirstViewController

@synthesize getLatitud;
@synthesize getLongitud;
@synthesize mapview;
@synthesize location;
@synthesize nomEquip;
@synthesize getNivellBatt;
@synthesize posCapturat;
@synthesize posEnviat;
@synthesize dataPosCap;



// interruptor Captura posicio
@synthesize capturaPos;

UIAlertView *alerta1;

NSURLConnection *connexio;
NSString *ID;
TWDataSend *enviament1;
NSMutableArray *buffer;
int capturat;
int enviat;
bool semafor;
int indexBuffer;
int numObj;
MKCoordinateSpan span;
MKCoordinateRegion region;


// interruptor de capturar posicions
-(IBAction)pulsador1:(id)sender{
    
    if (capturaPos.isOn){
        //self.location=nil;
        [self.location startUpdatingLocation];
    }
    else{
        //self.location=nil;
        [self.location stopUpdatingLocation];
    }
}


- (void)viewDidLoad
{
    
    [super viewDidLoad];
	   

    //*******************************************************************
    //   diccionari, per lectura inicial dels valors de configuració
    //        fitxer: TWSettingsList.plist
    //        
    NSString *path=[[NSBundle mainBundle] pathForResource:@"TWSettingsList" ofType:@"plist"];
    NSLog(@"%@",path);
    
    NSMutableDictionary *dic=[[NSMutableDictionary alloc]initWithContentsOfFile:path];
    
    //NSLog(path);
   
    //--------------------------------------------------------------------
    // assignació de la configuració del diccionari a les variables globals 
    gURL_REST=[dic objectForKey:@"URL_API_REST"];
    gNOM_EQUIP=[dic objectForKey:@"NOM_EQUIP"];
    gGPS_DISTANCIA=[dic objectForKey:@"DISTANCIA_GPS"];
    gGPS_MODUS=[dic objectForKey:@"GPS_DEFAULT_MODE"];
    
    dic =nil;
    path=nil;
    
    /*  test de les variables globals
    NSLog(gURL_REST);
    NSLog(gNOM_EQUIP);
    NSLog(gGPS_DISTANCIA);
    NSLog(gGPS_MODUS);
    */
    //NSLog(gGPS_MODUS);
    
    buffer=nil;
    buffer=[[NSMutableArray alloc]init];
    
    // lectura codi equip només un cop.
    self.nomEquip.text=gNOM_EQUIP;
    
    //  lectura del ID del dispositiu, només un cop.
    ID=self.getID;
    //NSLog(@"%@",ID);
    
    // coontrol de canvi d'estat a background/foreground
    gback=false;
    gfore=true;
    enviamentEnCurs=false;
    //
    // ajust visor del mapa
    span.latitudeDelta=.01;
    span.longitudeDelta=.01;

    // inici lectura posició
    [self starUpLocation];
    
   
    
    //NSLog(@"main exe fin");
}

-(void)starUpLocation{

    NSString *GPS_MOBILS=@"GPS-MOBILS";
    NSString *MOBILS_GPS=@"MOBILS-GPS";
    NSString *MOBILS=@"MOBILS";
    NSString *GPS=@"GPS";
    
    if (![CLLocationManager locationServicesEnabled]){
        // NSLog(@"activar location service");
     alerta1=[[UIAlertView alloc]initWithTitle:@"Servei de Localització" message:@"Es necessita l'activació" delegate:self cancelButtonTitle:@"Si" otherButtonTitles:@"No", nil];
      
    }
    // inicialitzar l'objecte location i la seva configuració inicial
    if ([CLLocationManager locationServicesEnabled]){
        self.location=nil;
        self.location=[[CLLocationManager alloc]init];
        self.location.delegate=self;
        //NSLog(@"loc manager activat");
        // modus gps
        if ([gGPS_MODUS isEqualToString:GPS_MOBILS]){
            self.location.desiredAccuracy=kCLLocationAccuracyHundredMeters;
            self.location.distanceFilter=99.0;
            self.location.headingFilter=99.0;
            // NSLog(@"gps i mobils cent metres");
        }
        if ([gGPS_MODUS isEqualToString:MOBILS_GPS]){
            self.location.desiredAccuracy=kCLLocationAccuracyKilometer;
            self.location.distanceFilter=999.0;
            self.location.headingFilter=999.0;
            // NSLog(@"mobil i gps mil metres");
        }
        if ([gGPS_MODUS isEqualToString:MOBILS]){
            self.location.desiredAccuracy=kCLLocationAccuracyThreeKilometers;
            self.location.distanceFilter=2999.0;
            self.location.headingFilter=2999.0;
            // NSLog(@"mobils 3mil metres");
        }
        if ([gGPS_MODUS isEqualToString:GPS]){
            self.location.desiredAccuracy=kCLLocationAccuracyNearestTenMeters;
            self.location.distanceFilter=9.0;
            self.location.headingFilter=9.0;
            //  NSLog(@"gps deu metres");
        }
        [self.location startUpdatingLocation];
    }
}


-(void) updateParam{

    NSString *GPS_MOBILS=@"GPS-MOBILS";
    NSString *MOBILS_GPS=@"MOBILS-GPS";
    NSString *MOBILS=@"MOBILS";
    NSString *GPS=@"GPS";
    
    [self.location stopUpdatingLocation];
    
    self.nomEquip.text=gNOM_EQUIP;
    
    if ([gGPS_MODUS isEqualToString:GPS_MOBILS]){
        self.location.desiredAccuracy=kCLLocationAccuracyHundredMeters;
        self.location.distanceFilter=99.0;
        self.location.headingFilter=99.0;
        // NSLog(@"gps i mobils cent metres");
    }
    if ([gGPS_MODUS isEqualToString:MOBILS_GPS]){
        self.location.desiredAccuracy=kCLLocationAccuracyKilometer;
        self.location.distanceFilter=999.0;
        self.location.headingFilter=999.0;
        // NSLog(@"mobil i gps mil metres");
    }
    if ([gGPS_MODUS isEqualToString:MOBILS]){
        self.location.desiredAccuracy=kCLLocationAccuracyThreeKilometers;
        self.location.distanceFilter=2999.0;
        self.location.headingFilter=2999.0;
        // NSLog(@"mobils 3mil metres");
    }
    if ([gGPS_MODUS isEqualToString:GPS]){
        self.location.desiredAccuracy=kCLLocationAccuracyNearestTenMeters;
        self.location.distanceFilter=9.0;
        self.location.headingFilter=9.0;
        //  NSLog(@"gps deu metres");
    }
    [self.location startUpdatingLocation];
   


}


// lestura estat bateria
-(NSString*)getEstatBateria{
    [[UIDevice currentDevice] setBatteryMonitoringEnabled:YES];
    UIDevice *myDev=[UIDevice currentDevice];
    [myDev setBatteryMonitoringEnabled:YES];
    int batLeft=[myDev batteryLevel]*100;
    if (batLeft<15){batLeft=15;}
    myDev = nil;
    return [NSString stringWithFormat:@"%d",batLeft];
}

// lectura del UUID 
-(NSString*)getID{
    [[UIDevice currentDevice] setBatteryMonitoringEnabled:YES];
    UIDevice *myDev=[UIDevice currentDevice];
    NSUUID *idDevice=myDev.identifierForVendor;
    myDev = nil;
    return idDevice.UUIDString;
}



// conversió de date a cadena
-(NSString*) convertToStr:(NSDate *) datax{
    NSDateFormatter *dateformater=[[NSDateFormatter alloc]init];
    dateformater.dateFormat=@"MM/dd/yy";
    NSString *dateStr=[dateformater stringFromDate:datax];
    dateformater.dateFormat=@" HH:mm:ss";
    NSString *timeStr=[dateformater stringFromDate:datax];
    NSString *strTot=[dateStr stringByAppendingString:timeStr];
    return strTot;
}


-(void) enviarDades:(TWDataSend *) val_env
{
    NSDate *datetime=val_env.getEntrada;
    
    NSString *str1=@"f=pjson&features=";
    NSString *str2=@"[{\"geometry\":{\"x\":";
    NSString *x=val_env.getPosX;
    NSString *str3=@",\"y\":";
    NSString *y=val_env.getPosY;
    NSString *str4=@",\"spatialReference\":{\"wkid\":104910}},\"attributes\":{\"uuid\":\"";
    NSString *uuid=val_env.getUUID;
    NSString *str5=@"\",\"equip\":\"";
    NSString *equip=val_env.getEquip;
    NSString *str6=@"\",\"bateria\":";
    NSString *bat=val_env.getBateria;
    NSString *str7=@",\"entrada\":\"";
    NSString *datTime=[self convertToStr:datetime];
    NSString *str8=@"\",\"tipus\":\"";
    NSString *tipus=val_env.getTipus;
    NSString *str9=@"\"}}]";
 
    NSString *strFinal=[str1 stringByAppendingString:str2];
    strFinal=[strFinal stringByAppendingString:x];
    strFinal=[strFinal stringByAppendingString:str3];
    strFinal=[strFinal stringByAppendingString:y];
    strFinal=[strFinal stringByAppendingString:str4];
    strFinal=[strFinal stringByAppendingString:uuid];
    strFinal=[strFinal stringByAppendingString:str5];
    strFinal=[strFinal stringByAppendingString:equip];
    strFinal=[strFinal stringByAppendingString:str6];
    strFinal=[strFinal stringByAppendingString:bat];
    strFinal=[strFinal stringByAppendingString:str7];
    strFinal=[strFinal stringByAppendingString:datTime];
    strFinal=[strFinal stringByAppendingString:str8];
    strFinal=[strFinal stringByAppendingString:tipus];
    strFinal=[strFinal stringByAppendingString:str9];
    //NSLog(@"%@", strFinal);
    
     NSString *postLength = [NSString stringWithFormat:@"%d", [strFinal length]];
     NSData *dataSend = [strFinal dataUsingEncoding:NSASCIIStringEncoding allowLossyConversion:YES];
    
     // connexió
     NSURL *address=[NSURL URLWithString:gURL_REST ];
     NSMutableURLRequest *request=[[NSMutableURLRequest alloc] init];
     [request setURL:address];
     [request setHTTPMethod:@"POST"];
     [request setValue:postLength forHTTPHeaderField:@"Content-Length"];
     [request setValue:@"application/x-www-form-urlencoded" forHTTPHeaderField:@"Content-Type"];
     [request setHTTPBody:dataSend ];
      // afagir enviament al buffer
     [buffer addObject:request];
      // enviament del buffer
      semafor=true;
      numObj=[buffer count];
      int i=0;
      while (numObj!=0){
        if (semafor){
         connexio = nil;
         indexBuffer=i;
         connexio= [[NSURLConnection alloc]initWithRequest:[buffer objectAtIndex:i] delegate:self startImmediately:YES];
    
          semafor=false;
         numObj--;
         i++;
        }
      }
        
    NSLog(@"enviar dades ok");
    
}

//----------------------------------------------------------------------------------
// Event per les noves posicions i enviament de les dades al servidor
-(void) locationManager:(CLLocationManager *)manager didUpdateToLocation:(CLLocation *)newLocation fromLocation:(CLLocation *)oldLocation
{
    
    
    
    if (!enviamentEnCurs) {
    //
    enviamentEnCurs=true;
    //
    region.center=newLocation.coordinate;
    region.span=span;
    [mapview setRegion:region animated:true];
    // latitud
    NSString *lat= [[NSString alloc]initWithFormat:@"%f",newLocation.coordinate.latitude];
    // longitud
    NSString *longi= [[NSString alloc]initWithFormat:@"%f",newLocation.coordinate.longitude];
    // data i hora
    NSDate *eventDate=newLocation.timestamp;
    // objecte TWDataSend
    enviament1=nil;
    enviament1=[TWDataSend alloc];    
    // entrada de valors
    [enviament1 setPosX:longi];
    [enviament1 setPosY:lat];
    [enviament1 setUUID:ID];
    [enviament1 setEquip:gNOM_EQUIP];
    [enviament1 setBateria:self.getEstatBateria];
    [enviament1 setEntrada:eventDate];
    [enviament1 setTipus:@"iPhone"];
    // comptador de poscicions capturades
    capturat++;
    posCapturat.text=[NSString stringWithFormat:@"%d",capturat];
    dataPosCap.text=[self convertToStr:eventDate];
    // enviament de les dades, Objecte TWSDataSend
    NSLog(@"captura OK");
    [self enviarDades:enviament1];
    NSLog(@"enviament fet");
    
        
    [self updateParam];
    
    }
    
}



// -------  events per la connexió amb el servidor ----------------------------
//
-(void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response{
    
    NSHTTPURLResponse *resposta=(NSHTTPURLResponse *)response;
    if ([resposta statusCode]>=400){
        NSLog(@"error de resposta: %d %@",[resposta statusCode],[NSHTTPURLResponse localizedStringForStatusCode:[resposta statusCode] ] );
        [connexio cancel];
        semafor=true;
        numObj=0;
        enviamentEnCurs=false;
    }else{
        NSLog(@"Resposta: %d %@",[resposta statusCode],[NSHTTPURLResponse localizedStringForStatusCode:[resposta statusCode] ] );
        
        enviat++;
        self.posEnviat.text=[NSString stringWithFormat:@"%d",enviat];
        [buffer removeObjectAtIndex:indexBuffer];
        [connexio cancel];
        semafor=true;
         enviamentEnCurs=false;
    }
}


-(void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error {
    NSLog(@"error .....%@", error);
    // error de time out
    [connexio cancel];
    semafor=true;
    numObj=0;
    enviamentEnCurs=false;
    }


-(void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data{
    
    NSString *res=[[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
    NSLog(@"dades rebudes....%@", res);
    
    enviat++;
    self.posEnviat.text=[NSString stringWithFormat:@"%d",enviat];
    
    [buffer removeObjectAtIndex:indexBuffer];
    [connexio cancel];
    semafor=true;
    enviamentEnCurs=false;
    
}

-(void)alertView:(UIAlertView *)alertView didDismissWithButtonIndex:(NSInteger)buttonIndex{
    
    if (buttonIndex==0){
        // si
        NSLog(@"Si");
       
    }
    
    if (buttonIndex==1){
        // no
        NSLog(@"No");
    }
}




- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    NSLog(@" warning de memoria !!!!");
    // Dispose of any resources that can be recreated.
}

@end
